       IDENTIFICATION DIVISION.
       PROGRAM-ID.    CUQCP1C1.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2019 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy and modify this software for a        *
      * non-commercial purpose and without fee is hereby granted,     *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *****************************************************************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT   SECTION.
       FILE-CONTROL.
      *****************************************************************
           SELECT CUSTSEQ1-FILE
               ASSIGN       to CUSTSEQ1
               ORGANIZATION is SEQUENTIAL
               ACCESS MODE  is SEQUENTIAL
               FILE STATUS  is CUSTSEQ1-STATUS.

      *****************************************************************
       DATA DIVISION.
       FILE SECTION.
       FD  CUSTSEQ1-FILE.
       COPY CUSTSQ01.

       WORKING-STORAGE SECTION.
      *****************************************************************
      *    Data-structure for Title and Copyright...
      *    ------------------------------------------------------------
       01  SIM-TITLE.
           05  T1 pic X(11) value '* CUQCP1C1 '.
           05  T2 pic X(34) value 'Cursor Processing, Customer RDB   '.
           05  T3 pic X(10) value ' v08.09.18'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* CUQCP1C1 '.
           05  C2 pic X(20) value 'Copyright 1987-2019 '.
           05  C3 pic X(28) value '    SimoTime Technologies   '.
           05  C4 pic X(20) value ' All Rights Reserved'.

       01  SIM-THANKS-01.
           05  C1 pic X(11) value '* CUQCP1C1 '.
           05  C2 pic X(32) value 'Thank you for using this program'.
           05  C3 pic X(32) value ' provided from SimoTime Technolo'.
           05  C4 pic X(04) value 'gies'.

       01  SIM-THANKS-02.
           05  C1 pic X(11) value '* CUQCP1C1 '.
           05  C2 pic X(32) value 'Please send all inquires or sugg'.
           05  C3 pic X(32) value 'estions to the helpdesk@simotime'.
           05  C4 pic X(04) value '.com'.

       01  CUSTSEQ1-STATUS.
           05  CUSTSEQ1-STAT1      pic X.
           05  CUSTSEQ1-STAT2      pic X.

       01  IO-STATUS.
           05  IO-STAT1            pic X.
           05  IO-STAT2            pic X.
       01  TWO-BYTES.
           05  TWO-BYTES-LEFT      pic X.
           05  TWO-BYTES-RIGHT     pic X.
       01  TWO-BYTES-BINARY        redefines TWO-BYTES pic 9(4) comp.

       01  END-OF-FILE             pic X(3)    value 'NO '.

       01  APPL-RESULT             pic S9(9)   comp.
           88  APPL-AOK            value 0.
           88  APPL-EOF            value 16.

      *****************************************************************
      *    Buffer used for posting messages to the console.
      *    ------------------------------------------------------------
       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* CUQCP1C1 '.
           05  MESSAGE-TEXT.
               10  MESSAGE-TEXT-1  pic X(68)   value SPACES.
               10  MESSAGE-TEXT-2  pic X(41)   value SPACES.
       01  MESSAGE-BUFFER-SIZE     pic 9(3)    value 120.

       01  DEBUG-FLAG              pic X       value 'Y'.
       01  CONNECT-FLAG            pic X       value 'N'.

       01  MSG-SQL-CODE.
           05  filler              pic X(2)    value '* '.
           05  FILLER              pic X(12)   value 'SQLCODE is  '.
           05  MSG-SQL-VALUE       pic S9(12)  SIGN LEADING SEPARATE
                                               value 0.

       01  MSG-SQL-STATE.
           05  filler              pic X(2)    value '* '.
           05  FILLER              pic X(12)   value 'SQLSTATE is '.
           05  MSG-SQL-STATE-5     pic X(5)    value SPACES.

       01  DISPLAY-LINE-01.
           05  filler              pic X(8)    value 'Cust #: '.
           05  DISPLAY-NUMBER      pic X(12)   value SPACES.
           05  filler              pic X(3)    value ' - '.
           05  DISPLAY-DESCRIPTION pic X(48)   value SPACES.

       01  FETCH-SUMMARY.
           05  filler      pic X(2)    value '* '.
           05  filler      pic X(23)   value 'Data Base FETCH count: '.
           05  FETCH-COUNT pic 9(7)    value 0.

       01  CUSTACC1-EOF                pic X      value 'N'.

      *****************************************************************
           EXEC SQL BEGIN DECLARE SECTION END-EXEC.

           EXEC SQL
                INCLUDE CUSTCQ01
           END-EXEC.

           EXEC SQL
              DECLARE CUCURSOR CURSOR FOR
              SELECT CUQ1_NUMBER,
                     CUQ1_STATUS,
                     CUQ1_LAST_NAME,
                     CUQ1_FIRST_NAME,
                     CUQ1_MID_NAME,
                     CUQ1_ADDRESS_1,
                     CUQ1_ADDRESS_2,
                     CUQ1_CITY,
                     CUQ1_STATE,
                     CUQ1_POSTAL_CODE,
                     CUQ1_PHONE_HOME,
                     CUQ1_PHONE_WORK,
                     CUQ1_PHONE_CELL,
                     CUQ1_LADATE,
                     CUQ1_LATIME,
                     CUQ1_TOKEN
              FROM CUSTACC1
              ORDER BY CUQ1_NUMBER
           END-EXEC.

           EXEC SQL INCLUDE
                SQLCA
           END-EXEC.

      *****************************************************************
       PROCEDURE DIVISION.

           perform Z-POST-COPYRIGHT

      *    Do an explicit connect or let the operating system or
      *    the Micro Focus sub-system manage the connect.
           if  CONNECT-FLAG = 'Y'
               perform CUSTACC1-CONNECT
           end-if

      *    EXEC SQL BEGIN TRANSACTION END-EXEC

           perform CUSTACC1-OPEN-CURSOR
           perform CUSTSEQ1-OPEN.

           perform until CUSTACC1-EOF not = 'N'
               perform CUSTACC1-FETCH
               if  CUSTACC1-EOF = 'N'
                   move CUQ1-RECORD to CUS1-RECORD
                   perform CUSTSEQ1-WRITE
               end-if
           end-perform

           perform CUSTSEQ1-CLOSE.
           perform CUSTACC1-CLOSE-CURSOR

           if  CONNECT-FLAG = 'Y'
               perform CUSTACC1-DISCONNECT
           end-if

           move FETCH-SUMMARY to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TO-CONSOLE

           perform Z-THANK-YOU.

           GOBACK.

      *****************************************************************
       CUSTACC1-CONNECT.
           EXEC SQL CONNECT TO 'CUSTACC1' user 'Admin' END-EXEC.
           evaluate SQLCODE
             when 0
               move 'Y' to CONNECT-FLAG
               move 0 to RETURN-CODE
               move '* Data Base CONNECT is Successful'
                 to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TO-SYSOUT
             when OTHER
               move '* ABENDING! CONNECT attempt Failed'
                 to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TO-SYSOUT
               perform Z-DISPLAY-SQL-MSGS-3
               add 16 to ZERO giving RETURN-CODE
               perform Z-ABEND-PROGRAM
           end-evaluate
           exit.

      *****************************************************************
       CUSTACC1-DISCONNECT.
           EXEC SQL DISCONNECT CURRENT END-EXEC.
           evaluate SQLCODE
             when 0
               move 'N' to CONNECT-FLAG
               move 0 to RETURN-CODE
               move '* Data Base DISCONNECT is Successful'
                 to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TO-SYSOUT
             when OTHER
               move '* ABENDING! DISCONNECT attempt Failed'
                 to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TO-SYSOUT
               perform Z-DISPLAY-SQL-MSGS-3
           end-evaluate
           exit.

      *****************************************************************
       CUSTACC1-OPEN-CURSOR.
           EXEC SQL OPEN CUCURSOR END-EXEC.

           evaluate SQLCODE
             when 0
               move '* Data Base OPEN CURSOR is Successful'
                 to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TO-SYSOUT
             when OTHER
               move 'A' to CUSTACC1-EOF
               add 16 to ZERO giving RETURN-CODE
               move '* ABENDING! OPEN CURSOR attempt has failed'
                 to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TO-CONSOLE
               perform Z-DISPLAY-SQL-MSGS-3
               perform Z-ABEND-PROGRAM
           end-evaluate
           exit.
      *---------------------------------------------------------------*
       CUSTACC1-FETCH.
           initialize CUQ1-RECORD
           EXEC SQL FETCH CUCURSOR
                INTO :CUQ1-NUMBER,
                     :CUQ1-STATUS,
                     :CUQ1-LAST-NAME,
                     :CUQ1-FIRST-NAME,
                     :CUQ1-MID-NAME,
                     :CUQ1-ADDRESS-1,
                     :CUQ1-ADDRESS-2,
                     :CUQ1-CITY,
                     :CUQ1-STATE,
                     :CUQ1-POSTAL-CODE,
                     :CUQ1-PHONE-HOME,
                     :CUQ1-PHONE-WORK,
                     :CUQ1-PHONE-CELL,
                     :CUQ1-LADATE,
                     :CUQ1-LATIME,
                     :CUQ1-TOKEN
           END-EXEC.
           evaluate SQLCODE
             when 0 move 0 to RETURN-CODE
                    add 1 to FETCH-COUNT
             when 1 move 0 to RETURN-CODE
                    add 1 to FETCH-COUNT
             when +100
               move 'Y' to CUSTACC1-EOF
               move '* Data Base FETCH is at End-of-File'
                 to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TO-SYSOUT
             when OTHER
               move 'A' to CUSTACC1-EOF
               add 16 to ZERO giving RETURN-CODE
               move 'ABENDING! FETCH attempt has failed'
                 to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TO-CONSOLE
               perform Z-DISPLAY-SQL-MSGS-3
           end-evaluate
           exit.
      *---------------------------------------------------------------*
       CUSTACC1-CLOSE-CURSOR.
           EXEC SQL CLOSE CUCURSOR END-EXEC.
           exit.

      *****************************************************************
       CUSTSEQ1-GET.
           read CUSTSEQ1-FILE
           if  CUSTSEQ1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  CUSTSEQ1-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if
           if  APPL-AOK
               CONTINUE
           else
               if  APPL-EOF
                   move 'YES' to END-OF-FILE
               end-if
           end-if
           exit.
      *---------------------------------------------------------------*
       CUSTSEQ1-WRITE.
           write CUS1-RECORD
           if  CUSTSEQ1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  CUSTSEQ1-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if
           if  APPL-AOK
               CONTINUE
           else
               if  APPL-EOF
                   move 'YES' to END-OF-FILE
               else
                   move 'CUSTSEQ1-FAILURE-WRITE...'
                     to   MESSAGE-TEXT
                   move CUSTSEQ1-STATUS to IO-STATUS
                   perform Z-DISPLAY-MESSAGE-TO-SYSOUT
                   perform Z-DISPLAY-IO-STATUS
                   perform Z-ABEND-PROGRAM
               end-if
           end-if
           exit.
      *---------------------------------------------------------------*
       CUSTSEQ1-REWRITE.
           REWRITE CUS1-RECORD
           if  CUSTSEQ1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  CUSTSEQ1-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if
           if  APPL-AOK
               CONTINUE
           else
               if  APPL-EOF
                   move 'YES' to END-OF-FILE
               else
                   move 'CUSTSEQ1-FAILURE-REWRITE...'
                     to   MESSAGE-TEXT
                   move CUSTSEQ1-STATUS to IO-STATUS
                   perform Z-DISPLAY-MESSAGE-TO-SYSOUT
                   perform Z-DISPLAY-IO-STATUS
                   perform Z-ABEND-PROGRAM
               end-if
           end-if
           exit.
      *---------------------------------------------------------------*
       CUSTSEQ1-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open OUTPUT CUSTSEQ1-FILE
           if  CUSTSEQ1-STATUS = '35'
               move 'CUSTSEQ1-FAILURE-OPEN-IO...'
                 to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TO-SYSOUT
               move CUSTSEQ1-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               move 'CUSTSEQ1-ATTEMPT-OPEN-OUTPUT...'
                 to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TO-SYSOUT
               open output CUSTSEQ1-FILE
           end-if
           if  CUSTSEQ1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CUSTSEQ1-FAILURE-OPEN...'
                 to MESSAGE-TEXT
               move CUSTSEQ1-STATUS to IO-STATUS
               perform Z-DISPLAY-MESSAGE-TO-SYSOUT
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       CUSTSEQ1-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close CUSTSEQ1-FILE
           if  CUSTSEQ1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CUSTSEQ1-FAILURE-CLOSE...'
                 to   MESSAGE-TEXT
               move CUSTSEQ1-STATUS to IO-STATUS
               perform Z-DISPLAY-MESSAGE-TO-SYSOUT
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * The following Z-Routines perform administrative tasks         *
      * for this program.                                             *
      *****************************************************************
       Z-ABEND-PROGRAM.
           if  MESSAGE-TEXT not = SPACES
               perform Z-DISPLAY-MESSAGE-TO-SYSOUT
           end-if
           move 'PROGRAM-IS-ABENDING...'  to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TO-SYSOUT
           if  CONNECT-FLAG = 'Y'
               perform CUSTACC1-DISCONNECT
           end-if
           add 12 to ZERO giving RETURN-CODE
           GOBACK.
      *    exit.
      *****************************************************************
      * Display the file status bytes. This routine will display as   *
      * two digits if the full two byte file status is numeric. If    *
      * second byte is non-numeric then it will be treated as a       *
      * binary number.                                                *
      *****************************************************************
       Z-DISPLAY-IO-STATUS.
           if  IO-STATUS not NUMERIC
           or  IO-STAT1 = '9'
               subtract TWO-BYTES-BINARY from TWO-BYTES-BINARY
               move IO-STAT2 to TWO-BYTES-RIGHT
               display '* CUQCP1C1 FILE-STATUS-' IO-STAT1 '/'
                       TWO-BYTES-BINARY upon console
           else
               display '* CUQCP1C1 FILE-STATUS-' IO-STATUS upon console
           end-if
           exit.
      *****************************************************************
       Z-POST-COPYRIGHT.
           display SIM-TITLE     upon console
           display SIM-COPYRIGHT upon console
           exit.

      *****************************************************************
       Z-DISPLAY-MESSAGE-TO-SYSOUT.
           if  MESSAGE-TEXT-2 = SPACES
               display MESSAGE-BUFFER(1:79) upon sysout
           else
               display MESSAGE-BUFFER       upon sysout
           end-if
           move all SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
       Z-DISPLAY-MESSAGE-TO-CONSOLE.
           if  MESSAGE-TEXT-2 = SPACES
               display MESSAGE-BUFFER(1:79) upon console
           else
               display MESSAGE-BUFFER       upon console
           end-if
           move all SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
       Z-DISPLAY-SQL-MSGS-3.
           perform Z-DISPLAY-SQL-CODE
           perform Z-DISPLAY-SQL-STATE
           perform Z-DISPLAY-SQL-ERRMC
           exit.

      *****************************************************************
       Z-DISPLAY-SQL-CODE.
           add SQLCODE to ZERO giving MSG-SQL-VALUE
           move MSG-SQL-CODE to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TO-CONSOLE
           exit.

      *****************************************************************
       Z-DISPLAY-SQL-STATE.
           move SQLSTATE to MSG-SQL-STATE-5
           move MSG-SQL-STATE to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TO-CONSOLE
           exit.

      *****************************************************************
       Z-DISPLAY-SQL-ERRMC.
           move sqlerrmc to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TO-CONSOLE
           exit.

      *****************************************************************
       Z-THANK-YOU.
           display SIM-THANKS-01 upon console
           display SIM-THANKS-02 upon console
           exit.

      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *         (C) Copyright 1987-2019 All Rights Reserved           *
      *           Web Site URL:   http://www.simotime.com             *
      *                 e-mail:   helpdesk@simotime.com               *
      *****************************************************************
