@echo OFF
rem  * *******************************************************************
rem  *               CUQCP1E1.CMD - a Windows Command File               *
rem  *         This program is provided by SimoTime Technologies         *
rem  *           (C) Copyright 1987-2019 All Rights Reserved             *
rem  *             Web Site URL:   http://www.simotime.com               *
rem  *                   e-mail:   helpdesk@simotime.com                 *
rem  * *******************************************************************
rem  *
rem  * Text    - COBOL with embedded SQL for Cursor Processing
rem  * Author  - SimoTime Technologies
rem  * Date    - November 11, 2003
rem  * Version - 08.07.25
rem  *
rem  * This set of programs illustrate the use of embedded SQL in a COBOL
rem  * program that fetches one row at a time from the CUST data base. A
rem  * sequential file containing one record for each row is created.
rem  *
rem  * This technique provides for the use of a single COBOL source
rem  * program that will run on ZOS, Windows or Unix.
rem  *
rem  * This set of programs will run on a Personal Computer with Windows
rem  * and Micro Focus Net Express or Mainframe Express.
rem  *
rem  *                    ************
rem  *                    * CUQCP1E1 *
rem  *                    ********cmd*
rem  *                         *
rem  *                         *
rem  *   ************     ************     ************
rem  *   * CUSTRDB1 *-----* CUQCP1C1 *-----* CUSTSEQ1 *
rem  *   ********rdb*     ********cbl*     *******rseq*
rem  *                         *
rem  *                         *
rem  *                    ************
rem  *                    *   EOJ    *
rem  *                    ************
rem  *
echo *
echo * The SQL Server must be started prior to executing this command.
echo *
     set CmdName=CUQCP1E1
     call ..\Env1BASE %CmdName%
     call SimoNOTE "*******************************************************%CmdName%"
     call SimoNOTE "Starting JobName %CmdName%"
     set CUSTSEQ1=%BASECAT%\APPL\SIMOTIME.DATA.CUSTSEQ2.dat
     run CUQCP1C2
     if errorlevel = 1 set JobStatus=0001
     if not "%JobStatus%" == "0000" goto :EojNOK
:EojAOK
     call SimoNOTE "Finished JobName %CmdName%"
     goto :End
:EojNOK
     call SimoNOTE "ABENDING JobName %CmdName%"
     call SimoNOTE "ABENDING Message JobStatus %JobStatus%"
     goto :End
:End
     if not "%1" == "nopause" pause
rem  * End-of-Command-File...
