       IDENTIFICATION DIVISION.
       PROGRAM-ID.    CUQCT1C1.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2019 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy and modify this software for a        *
      * non-commercial purpose and without fee is hereby granted,     *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *****************************************************************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.

      *****************************************************************
       DATA DIVISION.
       FILE SECTION.

       WORKING-STORAGE SECTION.
      *****************************************************************
      *    Data-structure for Title and Copyright...
      *    ------------------------------------------------------------
       01  SIM-TITLE.
           05  T1 pic X(11) value '* CUQCT1C1 '.
           05  T2 pic X(34) value 'Create a Table and an Index       '.
           05  T3 pic X(10) value ' v08.07.25'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* CUQCT1C1 '.
           05  C2 pic X(20) value 'Copyright 1987-2019 '.
           05  C3 pic X(28) value '    SimoTime Technologies   '.
           05  C4 pic X(20) value ' All Rights Reserved'.

       01  SIM-THANKS-01.
           05  C1 pic X(11) value '* CUQCT1C1 '.
           05  C2 pic X(32) value 'Thank you for using this program'.
           05  C3 pic X(32) value ' provided from SimoTime Technolo'.
           05  C4 pic X(04) value 'gies'.

       01  SIM-THANKS-02.
           05  C1 pic X(11) value '* CUQCT1C1 '.
           05  C2 pic X(32) value 'Please send all inquires or sugg'.
           05  C3 pic X(32) value 'estions to the helpdesk@simotime'.
           05  C4 pic X(04) value '.com'.

      *****************************************************************
      *    Buffer used for posting messages to the console.
      *    ------------------------------------------------------------
       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* CUQCT1C1 '.
           05  MESSAGE-TEXT        pic X(68).

           EXEC SQL
                INCLUDE SQLCA
           END-EXEC.

      *****************************************************************
       PROCEDURE DIVISION.

           perform Z-POST-COPYRIGHT

           perform CUSTRDB1-CREATE-TABLE

           perform CUSTRDB1-CREATE-INDEX

           perform Z-THANK-YOU.

           GOBACK.

      *****************************************************************
       CUSTRDB1-CREATE-TABLE.
           EXEC SQL
                CREATE TABLE CUSTRDB1
                (
                 CUQ1_NUMBER            CHAR (12)      NOT NULL
                                                       PRIMARY KEY,
                 CUQ1_STATUS            CHAR (1)       NOT NULL
                                                       WITH DEFAULT,
                 CUQ1_LAST_NAME         CHAR (28)      NOT NULL
                                                       WITH DEFAULT,
                 CUQ1_FIRST_NAME        CHAR (20)      NOT NULL
                                                       WITH DEFAULT,
                 CUQ1_MID_NAME          CHAR (20)      NOT NULL
                                                       WITH DEFAULT,
                 CUQ1_ADDRESS_1         CHAR (48)      NOT NULL
                                                       WITH DEFAULT,
                 CUQ1_ADDRESS_2         CHAR (48)      NOT NULL
                                                       WITH DEFAULT,
                 CUQ1_CITY              CHAR (28)      NOT NULL
                                                       WITH DEFAULT,
                 CUQ1_STATE             CHAR (28)      NOT NULL
                                                       WITH DEFAULT,
                 CUQ1_POSTAL_CODE       CHAR (12)      NOT NULL
                                                       WITH DEFAULT,
                 CUQ1_PHONE_HOME        CHAR (18)      NOT NULL
                                                       WITH DEFAULT,
                 CUQ1_PHONE_WORK        CHAR (18)      NOT NULL
                                                       WITH DEFAULT,
                 CUQ1_PHONE_CELL        CHAR (18)      NOT NULL
                                                       WITH DEFAULT,
                 CUQ1_CREDIT_LIMIT      DECIMAL (7,0)  NOT NULL
                                                       WITH DEFAULT,
                 CUQ1_DISCOUNT_CODE_1   INTEGER        NOT NULL
                                                       WITH DEFAULT,
                 CUQ1_DISCOUNT_RATE_1   NUMBER (2,3)   NOT NULL
                                                       WITH DEFAULT,
                 CUQ1_DISCOUNT_DATE_1   CHAR (8)       NOT NULL
                                                       WITH DEFAULT,
                 CUQ1_DISCOUNT_CODE_2   INTEGER        NOT NULL
                                                       WITH DEFAULT,
                 CUQ1_DISCOUNT_RATE_2   NUMBER (2,3)   NOT NULL
                                                       WITH DEFAULT,
                 CUQ1_DISCOUNT_DATE_2   CHAR (8)       NOT NULL
                                                       WITH DEFAULT,
                 CUQ1_DISCOUNT_CODE_3   INTEGER        NOT NULL
                                                       WITH DEFAULT,
                 CUQ1_DISCOUNT_RATE_3   NUMBER (2,3)   NOT NULL
                                                       WITH DEFAULT,
                 CUQ1_DISCOUNT_DATE_3   CHAR (8)       NOT NULL
                                                       WITH DEFAULT,
                 CUQ1_LADATE            CHAR (8)       NOT NULL
                                                       WITH DEFAULT,
                 CUQ1_LATIME            CHAR (8)       NOT NULL
                                                       WITH DEFAULT,
                 CUQ1_TOKEN             CHAR (8)       NOT NULL
                                                       WITH DEFAULT
                )
           END-EXEC

           if SQLCODE = 0
              display 'Finished CREATE of CUSTRDB1 '
           else
              display 'ABENDING CREATE of CUSTRDB1 '
                      'SQLCODE = ' SQLCODE
              add 16 to ZERO giving RETURN-CODE
           end-if
           exit.

      *****************************************************************
       CUSTRDB1-CREATE-INDEX.
           EXEC SQL
                CREATE UNIQUE INDEX CUSTIDX1
                ON CUSTRDB1(CUQ1_NUMBER ASC)
           END-EXEC

           if SQLCODE = 0
              display 'Finished CREATE INDEX for CUSTRDB1 '
           else
              display 'ABENDING CREATE INDEX for CUSTRDB1 '
                      'SQLCODE = ' SQLCODE
              add 16 to ZERO giving RETURN-CODE
           end-if
           exit.

      *****************************************************************
      * The following Z-Routines perform administrative tasks         *
      * for this program.                                             *
      *****************************************************************
       Z-POST-COPYRIGHT.
           display SIM-TITLE     upon console
           display SIM-COPYRIGHT upon console
           exit.

      *****************************************************************
       Z-POST-MESSAGE.
           display MESSAGE-BUFFER upon console
           move SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
       Z-THANK-YOU.
           display SIM-THANKS-01 upon console
           display SIM-THANKS-02 upon console
           exit.

      *****************************************************************
      *      This example is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
