       IDENTIFICATION DIVISION.
       PROGRAM-ID.    CUQUP1C1.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2019 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy and modify this software for a        *
      * non-commercial purpose and without fee is hereby granted,     *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *****************************************************************
      * This program will read the Item File (originally a VSAM, KSDS
      * downloaded to be a Micro Focus Keyed-Indexed file) and insert
      * or update rows into a table.
      *
      *                    ************
      *                    * CUQUP1J1 *
      *                    ********jcl*
      *                         *
      *                         *
      *                    ************
      *                    * IKJEFT01 *
      *                    ********dbm*
      *                         *
      *                         *
      *   ************     ************     ************
      *   * CUSTMAST *-----* CUQUP1C1 *-----* CUSTACC1 *
      *   ********ksd*     ********cbl*     ********rdb*
      *                         *
      *                         *
      *                    ************
      *                    *   EOJ    *
      *                    ************
      *
      *****************************************************************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
      *    The LINE SEQUENTIAL file organization is Micro Fcus
      *    syntax for an ASCII/Text file.
           SELECT CUSTMAST-FILE ASSIGN to CUSTMAST
                  ORGANIZATION  is indexed
                  ACCESS MODE   is SEQUENTIAL
                  RECORD KEY    is CUST-NUMBER
                  FILE STATUS   is CUSTMAST-STATUS.

      *****************************************************************
       DATA DIVISION.
       FILE SECTION.

       FD  CUSTMAST-FILE.
       COPY CUSTCB01.

       WORKING-STORAGE SECTION.
      *****************************************************************
      *    Data-structure for Title and Copyright...
      *    ------------------------------------------------------------
       01  SIM-TITLE.
           05  T1 pic X(11) value '* CUQUP1C1 '.
           05  T2 pic X(34) value 'Read KSDS, Update or Insert SQL   '.
           05  T3 pic X(10) value ' v09.02.12'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* CUQUP1C1 '.
           05  C2 pic X(20) value 'Copyright 1987-2019 '.
           05  C3 pic X(28) value '    SimoTime Technologies   '.
           05  C4 pic X(20) value ' All Rights Reserved'.

       01  SIM-THANKS-01.
           05  C1 pic X(11) value '* CUQUP1C1 '.
           05  C2 pic X(32) value 'Thank you for using this program'.
           05  C3 pic X(32) value ' provided from SimoTime Technolo'.
           05  C4 pic X(04) value 'gies'.

       01  SIM-THANKS-02.
           05  C1 pic X(11) value '* CUQUP1C1 '.
           05  C2 pic X(32) value 'Please send all inquires or sugg'.
           05  C3 pic X(32) value 'estions to the helpdesk@simotime'.
           05  C4 pic X(04) value '.com'.

       01  CUSTMAST-STATUS.
           05  CUSTMAST-STATUS-L   pic X.
           05  CUSTMAST-STATUS-R   pic X.
       01  CUSTMAST-EOF            pic X       value 'N'.
       01  CUSTMAST-OPEN-FLAG      pic X       value 'C'.


       01  CSVPUTD1-STATUS.
           05  CSVPUTD1-STATUS-L   pic X.
           05  CSVPUTD1-STATUS-R   pic X.
       01  CSVPUTD1-OPEN-FLAG      pic X       value 'C'.

       01  IO-STATUS.
           05  IO-STAT1            pic X.
           05  IO-STAT2            pic X.
       01  TWO-BYTES.
           05  TWO-BYTES-LEFT      pic X.
           05  TWO-BYTES-RIGHT     pic X.
       01  TWO-BYTES-BINARY        redefines TWO-BYTES pic 9(4) comp.
       01  IO-STATUS-4             pic 9(4)  value 0.
       01  IO-STATUS-4A            redefines IO-STATUS-4 pic X(4).

      *****************************************************************
      * Message Buffer used by the Z-DISPLAY-MESSAGE-TEXT routine.    *
      *****************************************************************
       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* CUQUP1C1 '.
           05  MESSAGE-TEXT.
               10  MESSAGE-TEXT-1  pic X(68)   value SPACES.
               10  MESSAGE-TEXT-2  pic X(41)   value SPACES.
       01  MESSAGE-BUFFER-SIZE     pic 9(3)    value 120.

       01  MSG-SQL-CODE.
           05  FILLER              pic X(12)   value ' SQLCODE is '.
           05  MSG-SQL-VALUE       pic S9(12)  SIGN LEADING SEPARATE
                                               value 0.

       01  WORK-DATE.
           05  WORK-DATE-08        pic X(8).
       01  WORK-TIME               pic X(8).

       01  EDIT-TIMESTAMP.
           05  EDIT-DATE           pic X(10)   value 'yyyy-nn-nn'.
           05  filler              pic X       value '-'.
           05  EDIT-TIME           pic X(11)   value 'nn:nn:nn:nn'.
           05  filler              pic X(4)    value SPACES.

       01  APPL-RESULT             pic S9(9)   comp.
           88  APPL-AOK            value 0.
           88  APPL-EOF            value 16.

       01  DEBUG-FLAG              pic X       value 'N'.
       01  CONNECT-FLAG            pic X       value 'N'.

      *    ------------------------------------------------------------
           EXEC SQL BEGIN DECLARE SECTION END-EXEC.

           EXEC SQL INCLUDE CUSTCQ01      END-EXEC.

       01  dbname PIC X(8)      value 'CUSTACC1'.
       01  userid PIC X(8)      value SPACES.
       01  p-word.
           49 L PIC S9(4) COMP-5   value 0.
           49 D PIC X(18)          value SPACES.

           EXEC SQL end DECLARE SECTION   END-EXEC.

           EXEC SQL INCLUDE SQLCA         END-EXEC.

      *****************************************************************
       PROCEDURE DIVISION.

           perform Z-POST-COPYRIGHT

           perform CUSTMAST-OPEN

           if  CONNECT-FLAG = 'Y'
      *        Do an explicit connect. Otherwise, operating system or
      *        Micro Focus sub-system should manage the connect.
               perform CUSTACC1-CONNECT
           end-if

           perform until CUSTMAST-STATUS not = '00'
               perform CUSTMAST-READ
      *        If a successful read of the input file and the
      *        input Customer Number is not equal to SPACES
      *        then create an output.
               if  CUSTMAST-STATUS = '00'
               and CUST-NUMBER not = SPACES
                   if  DEBUG-FLAG = 'Y'
                       display CUST-NUMBER ' - ' CUST-LAST-NAME
                   end-if
                   move CUST-RECORD      to CUQ1-RECORD
                   perform Z-GET-DATE-AND-TIME
                   perform CUSTACC1-SELECT
                   if  SQLCODE = ZERO
                   or  SQLCODE = 1
                       perform MOVE-DATA-FOR-UPDATE
                       perform CUSTACC1-UPDATE
                   else
                       perform MOVE-DATA-FOR-UPDATE
                       perform CUSTACC1-INSERT
                   end-if
               end-if
           end-perform

           if  CONNECT-FLAG = 'Y'
      *        Do an explicit connect. Otherwise, operating system or
      *        Micro Focus sub-system should manage the connect.
               perform CUSTACC1-DISCONNECT
           end-if

           perform CUSTMAST-CLOSE

           perform Z-THANK-YOU

           GOBACK.

      *****************************************************************
       CUSTACC1-CONNECT.
           EXEC SQL CONNECT TO 'CUSTACC1' END-EXEC
           evaluate SQLCODE
             when 0
               move 0 to RETURN-CODE
               move 'Y' to CONNECT-FLAG
               move '* CONNECT is Successful'
                 to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
             when OTHER
               move '* ABENDING: CONNECT attempt Failed'
                 to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               perform Z-DISPLAY-SQL-CODE
               add 16 to ZERO giving RETURN-CODE
               perform Z-ABEND-PROGRAM
           end-evaluate

           EXEC SQL BEGIN TRANSACTION END-EXEC
           exit.

      *****************************************************************
       CUSTACC1-DISCONNECT.
           EXEC SQL COMMIT TRANSACTION END-EXEC

           EXEC SQL DISCONNECT CURRENT END-EXEC
           move 'N' to CONNECT-FLAG
           exit.

      *****************************************************************
       MOVE-DATA-FOR-UPDATE.
           move CUST-NUMBER          to CUQ1-NUMBER
           move CUST-STATUS          to CUQ1-STATUS
           move CUST-LAST-NAME       to CUQ1-LAST-NAME
           move CUST-FIRST-NAME      to CUQ1-FIRST-NAME
           move CUST-MID-NAME        to CUQ1-MID-NAME
           move CUST-ADDRESS-1       to CUQ1-ADDRESS-1
           move CUST-ADDRESS-2       to CUQ1-ADDRESS-2
           move CUST-CITY            to CUQ1-CITY
           move CUST-STATE           to CUQ1-STATE
           move CUST-POSTAL-CODE     to CUQ1-POSTAL-CODE
           move CUST-PHONE-HOME      to CUQ1-PHONE-HOME
           move CUST-PHONE-WORK      to CUQ1-PHONE-WORK
           move CUST-PHONE-CELL      to CUQ1-PHONE-CELL

           move WORK-DATE            to CUQ1-LADATE
           move WORK-TIME            to CUQ1-LATIME
           move ZERO                 to CUQ1-TOKEN
           exit.

      *****************************************************************
       CUSTACC1-SELECT.
           EXEC SQL
                SELECT CUQ1_NUMBER,
                       CUQ1_STATUS,
                       CUQ1_LAST_NAME,
                       CUQ1_FIRST_NAME,
                       CUQ1_MID_NAME,
                       CUQ1_ADDRESS_1,
                       CUQ1_ADDRESS_2,
                       CUQ1_CITY,
                       CUQ1_STATE,
                       CUQ1_POSTAL_CODE,
                       CUQ1_PHONE_HOME,
                       CUQ1_PHONE_WORK,
                       CUQ1_PHONE_CELL,
                       CUQ1_LADATE,
                       CUQ1_LATIME,
                       CUQ1_TOKEN
                INTO :CUQ1-NUMBER,
                     :CUQ1-STATUS,
                     :CUQ1-LAST-NAME,
                     :CUQ1-FIRST-NAME,
                     :CUQ1-MID-NAME,
                     :CUQ1-ADDRESS-1,
                     :CUQ1-ADDRESS-2,
                     :CUQ1-CITY,
                     :CUQ1-STATE,
                     :CUQ1-POSTAL-CODE,
                     :CUQ1-PHONE-HOME,
                     :CUQ1-PHONE-WORK,
                     :CUQ1-PHONE-CELL,
                     :CUQ1-LADATE,
                     :CUQ1-LATIME,
                     :CUQ1-TOKEN
                FROM CUSTACC1
                WHERE CUQ1_NUMBER = :CUQ1-NUMBER
           END-EXEC

           if  DEBUG-FLAG = 'Y'
               display 'CUSTACC1 Last Name = ' CUQ1-LAST-NAME
               if SQLCODE = 0
               or SQLCODE = 1
                  if SQLCODE = 0
                     display 'SELECT row entry found'
                             ' Customer = ' CUQ1-NUMBER
                  else
                     display 'SELECT row entry found with NULLS'
                             ' Customer = ' CUQ1-NUMBER
                  end-if
                  perform Z-DISPLAY-SQL-CODE
               else
                  display 'SELECT row entry NOT found'
                          ' Customer = ' CUQ1-NUMBER
                  perform Z-DISPLAY-SQL-CODE
               end-if
           end-if

           if  SQLCODE NOT = ZERO
               initialize CUQ1-RECORD
           end-if
           exit.
      *---------------------------------------------------------------*
       CUSTACC1-INSERT.
           EXEC SQL
                INSERT into CUSTACC1
                 (
                  CUQ1_NUMBER,
                  CUQ1_STATUS,
                  CUQ1_LAST_NAME,
                  CUQ1_FIRST_NAME,
                  CUQ1_MID_NAME,
                  CUQ1_ADDRESS_1,
                  CUQ1_ADDRESS_2,
                  CUQ1_CITY,
                  CUQ1_STATE,
                  CUQ1_POSTAL_CODE,
                  CUQ1_PHONE_HOME,
                  CUQ1_PHONE_WORK,
                  CUQ1_PHONE_CELL,
                  CUQ1_LADATE,
                  CUQ1_LATIME,
                  CUQ1_TOKEN
                 )
                VALUES
                 (
                  :CUQ1-NUMBER,
                  :CUQ1-STATUS,
                  :CUQ1-LAST-NAME,
                  :CUQ1-FIRST-NAME,
                  :CUQ1-MID-NAME,
                  :CUQ1-ADDRESS-1,
                  :CUQ1-ADDRESS-2,
                  :CUQ1-CITY,
                  :CUQ1-STATE,
                  :CUQ1-POSTAL-CODE,
                  :CUQ1-PHONE-HOME,
                  :CUQ1-PHONE-WORK,
                  :CUQ1-PHONE-CELL,
                  :CUQ1-LADATE,
                  :CUQ1-LATIME,
                  :CUQ1-TOKEN
                 )
           END-EXEC

           if SQLCODE = 0
               if  DEBUG-FLAG = 'Y'
                   display 'Complete, INSERT FOR CUSTACC1'
                           'SQLCODE = ' SQLCODE
                           ' Customer = ' CUQ1-NUMBER
               end-if
           else
              display 'ABENDING! INSERT FOR CUSTACC1'
                      ' Customer = ' CUQ1-NUMBER
              perform Z-DISPLAY-SQL-CODE
              add 16 to ZERO giving RETURN-CODE
           end-if
           exit.
      *---------------------------------------------------------------*
       CUSTACC1-UPDATE.
           EXEC SQL
                UPDATE CUSTACC1
                SET CUQ1_NUMBER = :CUQ1-NUMBER,
                    CUQ1_STATUS = :CUQ1-STATUS,
                    CUQ1_LAST_NAME = :CUQ1-LAST-NAME,
                    CUQ1_FIRST_NAME = :CUQ1-FIRST-NAME,
                    CUQ1_MID_NAME = :CUQ1-MID-NAME,
                    CUQ1_ADDRESS_1 = :CUQ1-ADDRESS-1,
                    CUQ1_ADDRESS_2 = :CUQ1-ADDRESS-2,
                    CUQ1_CITY = :CUQ1-CITY,
                    CUQ1_STATE = :CUQ1-STATE,
                    CUQ1_POSTAL_CODE = :CUQ1-POSTAL-CODE,
                    CUQ1_PHONE_HOME = :CUQ1-PHONE-HOME,
                    CUQ1_PHONE_WORK = :CUQ1-PHONE-WORK,
                    CUQ1_PHONE_CELL = :CUQ1-PHONE-CELL,
                    CUQ1_LADATE = :CUQ1-LADATE,
                    CUQ1_LATIME = :CUQ1-LATIME,
                    CUQ1_TOKEN = :CUQ1-TOKEN
                WHERE CUQ1_NUMBER = :CUQ1-NUMBER
           END-EXEC.

           if  SQLCODE = 0
               if  DEBUG-FLAG = 'Y'
                   display 'Complete, UPDATE FOR CUSTACC1'
                           CUQ1-NUMBER
               end-if
           else
               display 'ABENDING, UPDATE FOR CUSTACC1 '
                       ' Customer = ' CUQ1-NUMBER
               perform Z-DISPLAY-SQL-CODE
               add 16 to ZERO giving RETURN-CODE
           end-if
           exit.

      *****************************************************************
      * I/O ROUTINES FOR CUSTMAST...                                  *
      *****************************************************************
       CUSTMAST-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close CUSTMAST-FILE
           if  CUSTMAST-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CUSTMAST-Failure-CLOSE...' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move CUSTMAST-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       CUSTMAST-READ.
           read CUSTMAST-FILE
           if  CUSTMAST-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  CUSTMAST-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if
           if  APPL-AOK
               CONTINUE
           else
               if  APPL-EOF
                   move 'Y' to CUSTMAST-EOF
               else
                   move 'CUSTMAST-Failure-GET...' to MESSAGE-TEXT
                   perform Z-DISPLAY-MESSAGE-TEXT
                   move CUSTMAST-STATUS to IO-STATUS
                   perform Z-DISPLAY-IO-STATUS
                   perform Z-ABEND-PROGRAM
               end-if
           end-if
           exit.
      *---------------------------------------------------------------*
       CUSTMAST-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open input CUSTMAST-FILE
           if  CUSTMAST-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to CUSTMAST-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CUSTMAST-Failure-OPEN...' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move CUSTMAST-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.


      *****************************************************************
      * The following Z-ROUTINES provide administrative functions     *
      * for this program.                                             *
      *****************************************************************
      *
      *****************************************************************
      * ABEND the program, post a message to the console and issue    *
      * a STOP RUN.                                                   *
      *****************************************************************
       Z-ABEND-PROGRAM.
           if  MESSAGE-TEXT not = SPACES
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           move 'PROGRAM-IS-ABENDING...'  to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT
           add 12 to ZERO giving RETURN-CODE
           STOP RUN.
      *    exit.

      *****************************************************************
      * Display CONSOLE messages...                                   *
      *****************************************************************
       Z-DISPLAY-MESSAGE-TEXT.
           if  MESSAGE-TEXT-2 = SPACES
               display MESSAGE-BUFFER(1:79)
           else
               display MESSAGE-BUFFER
           end-if
           move all SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
       Z-DISPLAY-SQL-CODE.
           add SQLCODE to ZERO giving MSG-SQL-VALUE
           move MSG-SQL-CODE to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT
           if SQLCODE not = 0
              move sqlerrmc to MESSAGE-TEXT
              perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           exit.

      *****************************************************************
      * Display the file status bytes. This routine will display as   *
      * four digits. If the full two byte file status is numeric it   *
      * will display as 00nn. If the 1st byte is a numeric nine (9)   *
      * the second byte will be treated as a binary number and will   *
      * display as 9nnn.                                              *
      *****************************************************************
       Z-DISPLAY-IO-STATUS.
           if  IO-STATUS not NUMERIC
           or  IO-STAT1 = '9'
               subtract TWO-BYTES-BINARY from TWO-BYTES-BINARY
               move IO-STAT2 to TWO-BYTES-RIGHT
               add TWO-BYTES-BINARY to ZERO giving IO-STATUS-4
               move IO-STAT1 to IO-STATUS-4A(1:1)
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-4A to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           else
               move '0000' to IO-STATUS-4A
               move IO-STATUS to IO-STATUS-4A(3:2)
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-4A to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           exit.

      *****************************************************************
       Z-GET-DATE-AND-TIME.
           accept WORK-DATE from DATE YYYYMMDD
           accept WORK-TIME from TIME

           move WORK-DATE(1:4) to EDIT-DATE(1:4)
           move WORK-DATE(5:2) to EDIT-DATE(6:2)
           move WORK-DATE(7:2) to EDIT-DATE(9:2)

           move WORK-TIME(1:2) to EDIT-TIME(1:2)
           move WORK-TIME(3:2) to EDIT-TIME(4:2)
           move WORK-TIME(5:2) to EDIT-TIME(7:2)
           move WORK-TIME(7:2) to EDIT-TIME(10:2)

           exit.

      *****************************************************************
       Z-POST-COPYRIGHT.
           display SIM-TITLE     upon console
           display SIM-COPYRIGHT upon console
           exit.

      *****************************************************************
       Z-THANK-YOU.
           display SIM-THANKS-01 upon console
           display SIM-THANKS-02 upon console
           exit.

      *****************************************************************
      *                 This program is provided by:                  *
      *                    SimoTime Technologies                      *
      *         (C) Copyright 1987-2019 All Rights Reserved           *
      *           Web Site URL:   http://www.simotime.com             *
      *                 e-mail:   helpdesk@simotime.com               *
      *****************************************************************
