       IDENTIFICATION DIVISION.
       PROGRAM-ID.    SQLDATC1.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2019 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy and modify this software for a        *
      * non-commercial purpose and without fee is hereby granted,     *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *****************************************************************
      * Oracle    Timestamp = 12-JUL-2004 12:00:30.00


      *****************************************************************
       DATA DIVISION.
       WORKING-STORAGE SECTION.
      *****************************************************************
      *    Data-structure for Title and Copyright...
      *    ------------------------------------------------------------
       01  SIM-TITLE.
           05  T1 pic X(11) value '* SQLDATC1 '.
           05  T2 pic X(34) value 'Read KSDS, Update or Insert SQL   '.
           05  T3 pic X(10) value ' v04.12.01'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* SQLDATC1 '.
           05  C2 pic X(20) value 'Copyright 1987-2019 '.
           05  C3 pic X(28) value '    SimoTime Technologies   '.
           05  C4 pic X(20) value ' All Rights Reserved'.

       01  SIM-THANKS-01.
           05  C1 pic X(11) value '* SQLDATC1 '.
           05  C2 pic X(32) value 'Thank you for using this program'.
           05  C3 pic X(32) value ' provided from SimoTime Technolo'.
           05  C4 pic X(04) value 'gies'.

       01  SIM-THANKS-02.
           05  C1 pic X(11) value '* SQLDATC1 '.
           05  C2 pic X(32) value 'Please send all inquires or sugg'.
           05  C3 pic X(32) value 'estions to the helpdesk@simotime'.
           05  C4 pic X(04) value '.com'.

      *****************************************************************
      * Message Buffer used by the Z-DISPLAY-MESSAGE-TEXT routine.    *
      *****************************************************************
       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* SQLDATC1 '.
           05  MESSAGE-TEXT.
               10  MESSAGE-TEXT-1  pic X(68)   value SPACES.
               10  MESSAGE-TEXT-2  pic X(188)  value SPACES.
       01  MESSAGE-BUFFER-SIZE     pic 9(3)    value 267.
       01  MSG-PTR                 pic 9(3)    value 0.
       01  MSG-LEN                 pic 9(3)    value 0.

       01  CREATE-TABLE            pic X       value 'N'.

       01 WS-DATE PIC X(8).
       01 WS-TIME PIC X(8).

       01  WORK-DATE.
           05  WORK-DATE-08        pic X(8).
       01  WORK-TIME               pic X(8).

       01  TIMESTAMP               pic X(23)   value SPACES.

       01  EDIT-TIMESTAMP.
           05  EDIT-DATE           pic X(10)   value 'yyyy-nn-nn'.
           05  filler              pic X       value '-'.
           05  EDIT-TIME           pic X(11)   value 'nn:nn:nn:nn'.
           05  filler              pic X(4)    value SPACES.

       01  MSSQL-TIMESTAMP.
           05  MSSQL-DATE          pic X(10)   value 'yyyy-nn-nn'.
           05  filler              pic X       value '-'.
           05  MSSQL-TIME          pic X(11)   value 'nn:nn:nn:nn'.
           05  filler              pic X(4)    value SPACES.

      *    ------------------------------------------------------------
           EXEC SQL BEGIN DECLARE SECTION END-EXEC.

           EXEC SQL DECLARE ITEMRDB1 TABLE
           (
                 CURRENT_DATE            CHAR (8)      NOT NULL,
                 CURRENT_TIME            CHAR (8)      NOT NULL,
                 EDIT_TIMESTAMP          CHAR (26)     NOT NULL
           )
           END-EXEC.

       01  DATERDB1-RECORD.
           05  DATERDB1-DATE             PIC X(8).
           05  DATERDB1-TIME             PIC X(8).
           05  DATERDB1-TIMESTAMP        PIC X(26).
      *----DATERDB1 - End-of-DECLARE...

           EXEC SQL end DECLARE SECTION   END-EXEC.

           EXEC SQL INCLUDE SQLCA         END-EXEC.

      *****************************************************************
       PROCEDURE DIVISION.
           perform Z-POST-COPYRIGHT

           perform Z-GET-DATE-AND-TIME
           display EDIT-TIMESTAMP

           EXEC SQL SET OPTION :WS-DATE = CURRENT_DATE END-EXEC

           EXEC SQL SET OPTION :WS-TIME = CURRENT_TIME END-EXEC

           DISPLAY 'DATE= ' WS-DATE
           DISPLAY 'TIME= ' WS-TIME

           if  CREATE-TABLE = 'Y'
               perform DATERDB1-CREATE-TABLE
           end-if

           perform Z-GET-DATE-AND-TIME
           perform MOVE-DATA-FOR-INSERT
           EXEC SQL
                INSERT into DATERDB1
                 (
                  CURRENT_DATE,
                  CURRENT_TIME,
                  EDIT_TIMESTAMP
                 )
                VALUES
                 (
                  :DATERDB1-DATE,
                  :DATERDB1-TIME,
                  :DATERDB1-TIMESTAMP
                 )
           END-EXEC

           if SQLCODE = 0
              display 'INSERTED ON INSERT FOR DATERDB1 '
                      'SQLCODE = ' SQLCODE
           else
              display 'ABENDING ON INSERT FOR DATERDB1 '
                      'SQLCODE = ' SQLCODE
              add 16 to ZERO giving RETURN-CODE
           end-if

           perform Z-GET-DATE-AND-TIME
           perform MOVE-DATA-FOR-INSERT
           move SPACES to DATERDB1-TIMESTAMP(20:7)
           perform INSERT-A-ROW

           perform 1000 times
               perform Z-GET-DATE-AND-TIME
               perform MOVE-DATA-FOR-INSERT
               perform INSERT-A-ROW
           end-perform

           perform Z-THANK-YOU

           GOBACK.

      *****************************************************************
       INSERT-A-ROW.
           EXEC SQL
                INSERT into DATERDB1
                 (
                  CURRENT_DATE,
                  CURRENT_TIME,
                  EDIT_TIMESTAMP
                 )
                VALUES
                 (
                  :DATERDB1-DATE,
                  :DATERDB1-TIME,
                  :DATERDB1-TIMESTAMP
                 )
           END-EXEC

           if SQLCODE = 0
              display 'INSERTED ON INSERT FOR DATERDB1 '
                      'SQLCODE = ' SQLCODE
           else
              display 'ABENDING ON INSERT FOR DATERDB1 '
                      'SQLCODE = ' SQLCODE
              add 16 to ZERO giving RETURN-CODE
           end-if
           exit.

      *****************************************************************
       MOVE-DATA-FOR-INSERT.
           move WORK-DATE      to DATERDB1-DATE
           move WORK-TIME      to DATERDB1-TIME
           move EDIT-TIMESTAMP to DATERDB1-TIMESTAMP
           exit.

      *****************************************************************
       DATERDB1-CREATE-TABLE.
           EXEC SQL
                CREATE TABLE DATERDB1
                (
                 CURRENT_DATE           CHAR (8)      NOT NULL,
                 CURRENT_TIME           CHAR (8)      NOT NULL,
                 EDIT_TIMESTAMP         CHAR(26)       NOT NULL
                )
           END-EXEC

           if SQLCODE = 0
              display 'Finished CREATE of DATERDB1 '
           else
              display 'ABENDING CREATE of DATERDB1 '
                      'SQLCODE = ' SQLCODE
              add 16 to ZERO giving RETURN-CODE
           end-if
           exit.

      *****************************************************************
      * The following Z-ROUTINES provide administrative functions     *
      * for this program.                                             *
      *****************************************************************
      *
      *****************************************************************
      * ABEND the program, post a message to the console and issue    *
      * a STOP RUN.                                                   *
      *****************************************************************
       Z-ABEND-PROGRAM.
           if  MESSAGE-TEXT not = SPACES
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           move 'PROGRAM-IS-ABENDING...'  to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT
           add 12 to ZERO giving RETURN-CODE
           STOP RUN.
      *    exit.

      *****************************************************************
      * Display CONSOLE messages...                                   *
      *****************************************************************
       Z-DISPLAY-MESSAGE-TEXT.
           display MESSAGE-BUFFER upon console
           move all SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
       Z-GET-DATE-AND-TIME.
           accept WORK-DATE from DATE YYYYMMDD
           accept WORK-TIME from TIME

           move WORK-DATE(1:4) to EDIT-DATE(1:4)
           move WORK-DATE(5:2) to EDIT-DATE(6:2)
           move WORK-DATE(7:2) to EDIT-DATE(9:2)

           move WORK-TIME(1:2) to EDIT-TIME(1:2)
           move WORK-TIME(3:2) to EDIT-TIME(4:2)
           move WORK-TIME(5:2) to EDIT-TIME(7:2)
           move WORK-TIME(7:2) to EDIT-TIME(10:2)

           exit.

      *****************************************************************
       Z-POST-COPYRIGHT.
           display SIM-TITLE     upon console
           display SIM-COPYRIGHT upon console
           exit.

      *****************************************************************
       Z-THANK-YOU.
           display SIM-THANKS-01 upon console
           display SIM-THANKS-02 upon console
           exit.

      *****************************************************************
      *                 This program is provided by:                  *
      *                    SimoTime Technologies                      *
      *         (C) Copyright 1987-2019 All Rights Reserved           *
      *           Web Site URL:   http://www.simotime.com             *
      *                 e-mail:   helpdesk@simotime.com               *
      *****************************************************************
